#include  <exec/types.h>
#include  <proto/graphics.h>
#include  <proto/intuition.h>
#include  <proto/exec.h>
#include  <proto/gadtools.h>
#include  <time.h>
#include  <stdio.h>

#include "PathFinderCalculs.h"


#define GD_CLEAR                               0
#define GD_CHOIX                               1
#define GD_CALCULE                             2
#define GD_DIAGONALE                           3

#define PathFinder_CNT 4

extern struct IntuitionBase *IntuitionBase;
extern struct Library       *GadToolsBase;


#define DECAL_X         10

#define DECAL_Y         30


static struct Screen         *Scr = NULL;
static APTR                   VisualInfo = NULL;
static struct Window         *PathFinderWnd = NULL;
static struct Gadget         *PathFinderGList = NULL;


static UBYTE *CHOIX[] = {
    (UBYTE *)"Obstacle",
    (UBYTE *)"Gomme",
    (UBYTE *)"Dpart",
    (UBYTE *)"Arrive",
    NULL };

static UWORD PathFinderGTypes[] = {
    BUTTON_KIND,
    MX_KIND,
    BUTTON_KIND,
    CHECKBOX_KIND
};

static struct NewGadget PathFinderNGad[] = 
    {
    430, 57, 89, 31, (UBYTE *)"Efface", NULL, GD_CLEAR, PLACETEXT_IN, NULL, NULL,
    430, 99, 17, 9, NULL, NULL, GD_CHOIX, PLACETEXT_RIGHT, NULL, NULL,
    430, 355, 96, 34, (UBYTE *)"Calculer", NULL, GD_CALCULE, PLACETEXT_IN, NULL, NULL,
    430, 235, 26, 11, (UBYTE *)"Diagonale autorise", NULL, GD_DIAGONALE, PLACETEXT_RIGHT, NULL, NULL
    };

static ULONG PathFinderGTags[] = {
    (GT_Underscore), '_', (TAG_DONE),
    (GTMX_Labels), (ULONG)&CHOIX[ 0 ], (TAG_DONE),
    (TAG_DONE),
    (TAG_DONE)
};



static int Radio_Type_Case = 0;
//
//
// Variables ncessaires pour la MAP
//
//
int xStart,yStart,						//coordonnes du point de dpart dans la matrice
	xGoal,yGoal;						//coordonnes du point d'arrive dans la matrice

int Diagonales = 0;


static int SetupScreen( void )
{
    if ( ! ( Scr = LockPubScreen( NULL ) ) )
        return( 1L );

    if ( ! ( VisualInfo = GetVisualInfo( Scr, TAG_DONE )))
        return( 2L );

    return( 0L );
}


static void CloseDownScreen( void )
{
    if ( VisualInfo )
        {
        FreeVisualInfo( VisualInfo );
        VisualInfo = NULL;
        }

    if ( Scr )
        {
        UnlockPubScreen( NULL, Scr );
        Scr = NULL;
        }
}


static void DessinerGrille( struct RastPort * rp )
{
    long i;

    SetAPen( rp, 1 );
    for ( i = 0; i <= 400; i += 10 )
        {
        Move( rp, DECAL_X + 1, DECAL_Y + i );
        Draw( rp, DECAL_X + 400, DECAL_Y + i );
        Move( rp, DECAL_X + i, DECAL_Y + 1 );
        Draw( rp, DECAL_X + i, DECAL_Y + 400 );
        }
}


static void DessineUneCase( struct RastPort * rp, int i, int j )
{
    long x, y;

    if ( i >= 0 && i < 40 && j >= 0 && j < 40 )
        {
        x = 1 + ( DECAL_X + 10 * i );
        y = 1 + ( DECAL_Y + 10 * j );
        switch( GetCase( i, j ) )
            {
            case CASE_VIDE :
                SetAPen( rp, 0 );
                break;

            case CASE_PLEINE:
                SetAPen( rp, 1 );
                break;

            case CASE_DEPART:
                SetAPen( rp, 2 );
                break;

            case CASE_ARRIVEE:
                SetAPen( rp, 3 );
                break;
            }
        RectFill( rp, x, y, x + 8, y + 8 );
        }
}


// fonction traant les obstacles de la map
static void DessinerCases( struct RastPort * rp )
{
    int i, j;

    for ( i = 0; i < 40; i++ )
        for ( j = 0; j < 40; j++ )
            DessineUneCase( rp, i, j );
}


static void DessinerChemin( struct RastPort * rp )
{
    StNoeud * Temp = Open;
    long x, y;

    SetAPen( rp, 3 );
    while( Temp != NULL )
        {
        x = 5 + (DECAL_X + 10 * Temp->x );
        y = 5 + ( DECAL_Y + 10 * Temp->y );
        DrawEllipse( rp, x, y, 3, 3 );
        Temp=Temp->Parent;
        }
}


static void DessinerMap( struct RastPort * rp )
{
    DessinerGrille( rp );
    DessinerCases( rp );
    DessinerChemin( rp );
}


static void CLEARClicked( struct RastPort * rp )
{
    xStart = -1;
    yStart = -1;
    xGoal = -1;
    yGoal = -1;
    Liberer_Listes();
    EffaceMap();
    DessinerMap( rp );
}


static void AfficheChaine( struct RastPort * rp, char * ch, LONG x, LONG y )
{
  static struct IntuiText TxtInfo = { 1, 0, JAM2, 4, 12, NULL, NULL, 0 };

  TxtInfo.IText = ( UBYTE * )ch;
  PrintIText( rp, &TxtInfo, x, y );
}


static void CALCULEClicked( struct RastPort * rp )
{
    int tps, Longueur = 0;        //nb de cases que comporte le chemin
    StNoeud * Temp;
    unsigned int Chrono1[ 2 ], Chrono2[ 2 ];
    char s[ 80 ];

    if (xStart == -1 || xGoal == -1)
        {
        //MessageBox("Vous devez dfinir les points de dpart\r\net d'arrive avant de lancer la recherche.","Erreur - PathFinding",MB_ICONINFORMATION);
        return;
        }

    //rcupration des donnes
    Liberer_Listes();

    //recherche du chemin
    timer( Chrono1 );
    AStarSearch(xStart,yStart,xGoal,yGoal,Diagonales);
    timer( Chrono2 );
    tps = ( Chrono2[ 1 ] - Chrono1[ 1 ] + 1000 * ( Chrono2[ 0 ] - Chrono1[ 0] ) ) / 1000;
    
    //mise  jour des informations de la fentre
    //calcul de la longueur du chemin
    Temp = Open;
    while (Temp!=NULL)
        {
        Longueur++;
        //passage au noeud parent
        Temp=Temp->Parent;
    }

    sprintf( s, "Temps = %d ms, Nb_Noeuds = %d, Longueur = %d      ", tps, Nb_Noeuds, Longueur );
    AfficheChaine( rp, s, 50, 440 );
    //on raffiche la map entire et on met  jour les informations de la fentre
    DessinerMap( rp );
}


static void BoutonSouris( struct RastPort * rp, int xPos, int yPos )
{
    if ( xPos >= 0 && xPos < 40 && yPos >= 0 && yPos < 40 )
        {
        switch( Radio_Type_Case )
            {
            case 0:     // Obstacle
                if (xPos == xStart && yPos == yStart)
                    xStart = -1,yStart = -1;    //efface le point de dpart

                if (xPos == xGoal && yPos == yGoal)
                    xGoal = -1,yGoal = -1;            //efface le point de dpart

                SetCase(xPos,yPos,CASE_PLEINE);
                break;

            case 1:     // Gomme
                if (xPos == xStart && yPos == yStart)
                    xStart = -1,yStart = -1;    //efface le point de dpart

                if (xPos == xGoal && yPos == yGoal)
                    xGoal = -1,yGoal = -1;            //efface le point de dpart

                SetCase( xPos, yPos, CASE_VIDE );
                break;

            case 2:     // Position dpart
                //on efface l'ancienne position et on affecte la nouvelle
                if (GetCase(xPos,yPos) != CASE_PLEINE && (xPos != xGoal || yPos != yGoal))
                    {
                    SetCase( xStart, yStart, CASE_VIDE );
                    DessineUneCase( rp, xStart, yStart );
                    SetCase( xPos, yPos, CASE_DEPART );
                    xStart = xPos;
                    yStart = yPos;
                    }
                break;

            case 3:     // Position arrive
                //on efface l'ancienne position et on affecte la nouvelle
                if (GetCase(xPos,yPos) != CASE_PLEINE && (xPos != xStart || yPos != yStart))
                    {
                    SetCase(xGoal,yGoal,CASE_VIDE);
                    DessineUneCase( rp, xGoal, yGoal );
                    SetCase(xPos,yPos,CASE_ARRIVEE);
                    xGoal=xPos;
                    yGoal=yPos;
                    }
                break;
            }
        DessineUneCase( rp, xPos, yPos );
        }
}


static void HandlePathFinderIDCMP( struct RastPort * rp )
{
    struct IntuiMessage    *m;
    struct Gadget * gadget;
    BOOL            running = TRUE;
    USHORT Bp = SELECTUP;

    while( running ) {
    while( m = GT_GetIMsg( PathFinderWnd->UserPort ) )
        {
        GT_ReplyIMsg( m );
        switch ( m->Class )
            {
            case IDCMP_REFRESHWINDOW:
                GT_BeginRefresh( PathFinderWnd );
                GT_EndRefresh( PathFinderWnd, TRUE );
                break;

            case IDCMP_CLOSEWINDOW:
                running = FALSE;
                break;

            case IDCMP_MOUSEBUTTONS:
                Bp = m->Code;
                if ( Bp == SELECTUP )
                    BoutonSouris( rp
                                , ( m->MouseX - DECAL_X ) / 10
                                , ( m->MouseY - DECAL_Y ) / 10
                                );
                break;

            case MOUSEMOVE:
                if ( Bp == SELECTDOWN )
                    BoutonSouris( rp
                                , ( m->MouseX - DECAL_X ) / 10
                                , ( m->MouseY - DECAL_Y ) / 10
                                );
                break;

            case IDCMP_GADGETUP:
            case IDCMP_GADGETDOWN:
                gadget = ( struct Gadget * )m->IAddress;
                switch( gadget->GadgetID )
                    {
                    case GD_CLEAR :
                        CLEARClicked( rp );
                        break;

                    case GD_CHOIX :
                        Radio_Type_Case = m->Code;
                        break;

                    case GD_CALCULE :
                        CALCULEClicked( rp );
                        break;

                    case GD_DIAGONALE :
                        Diagonales = m->Code;
                        break;
                    }
                break;
            }
        }
    }
}


static int OpenPathFinderWindow( void )
{
    struct NewGadget    ng;
    struct Gadget    *g;
    UWORD        lc, tc;

    if ( ! ( g = CreateContext( &PathFinderGList )))
        return( 1L );

    for ( lc = 0, tc = 0; lc < PathFinder_CNT; lc++ )
        {
        CopyMem((char * )&PathFinderNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

        ng.ng_VisualInfo = VisualInfo;

        g = CreateGadgetA((ULONG)PathFinderGTypes[ lc ], g, &ng, ( struct TagItem * )&PathFinderGTags[ tc ] );

        while( PathFinderGTags[ tc ] ) tc += 2;
        tc++;

        if ( NOT g )
            return( 2L );
        }

    if ( ! ( PathFinderWnd = OpenWindowTags( NULL,
                WA_Width,    640,
                WA_Height,   512,
                WA_IDCMP,    MXIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_MOUSEBUTTONS|IDCMP_MOUSEMOVE,
                WA_Flags,    WFLG_SIZEGADGET|WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_CLOSEGADGET|WFLG_SMART_REFRESH|WFLG_REPORTMOUSE,
                WA_Gadgets,  PathFinderGList,
                WA_PubScreen,Scr,
                TAG_DONE )))
        return( 4L );

    GT_RefreshWindow( PathFinderWnd, NULL );

    return( 0L );
}


static void ClosePathFinderWindow( void )
{
    if ( PathFinderWnd )
        {
        CloseWindow( PathFinderWnd );
        PathFinderWnd = NULL;
        }

    if ( PathFinderGList )
        {
        FreeGadgets( PathFinderGList );
        PathFinderGList = NULL;
        }
}


void main( void )
{
    if ( ! SetupScreen() )
        {
        if ( ! OpenPathFinderWindow() )
            {
            //valeurs par dfaut
            xStart = -1;
            yStart = -1;
            xGoal = -1;
            yGoal = -1;
            DessinerMap( PathFinderWnd->RPort );
            HandlePathFinderIDCMP( PathFinderWnd->RPort );
            Liberer_Listes();
            }
        ClosePathFinderWindow();
        }
    CloseDownScreen();
}
