#ifndef PATHFINDERCALCULS_H
#define PATHFINDERCALCULS_H


#define     TAILLE_X        40
#define     TAILLE_Y        40


typedef struct Noeud
    {
    struct Noeud * Parent,      //pointeur vers le noeud parent
                 * Suivant,     //pointeur vers le noeud suivant, dans la liste
                 * Precedent;   //pointeur vers le noeud prcdent, dans la liste
    int x, y;                   //coordonnes dans la matrice
    long CostFromStart,        //cot du chemin entre Start et ce noeud
          CostToGoal;           //cot du chemin entre ce noeud et Goal
    } StNoeud;


enum { ERREUR = -1, CASE_VIDE, CASE_PLEINE, CASE_DEPART, CASE_ARRIVEE };


void InitPathFinderCalculs( void );

void EffaceMap( void );

char GetCase( int x, int y );

void SetCase( int x, int y, char Valeur );

void AStarSearch( int xStart, int yStart, int xGoal, int yGoal, int Diagonales );

void Liberer_Listes( void );


extern int Nb_Noeuds;

extern StNoeud * Open, * Closed;


#endif
